<?php
namespace wcf\system\event\listener;
use wcf\acp\form\PageAddForm;
use wcf\acp\form\PageEditForm;
use wcf\system\WCF;

/**
 * Adds / edit the last edit time to a page.
 *
 * @author      Simon
 * @copyright	2020 simon-dev.net
 * @license	GNU Lesser General Public License <http://opensource.org/licenses/lgpl-license.php>
 */
class PageAddFormLastEditPageListener implements IParameterizedEventListener {
    public $enableLastEditPage = 0;
    /**
     * @inheritDoc
     */
    protected $eventObj;
    /**
     * @inheritDoc
     */
    public function execute($eventObj, $className, $eventName, array &$parameters) {
        $this->eventObj = $eventObj;
        $this->$eventName();
    }

    /**
     * readFormParameters event
     */
    protected function readFormParameters() {
        $this->eventObj->additionalFields['enableLastEditPage'] = isset($_POST['enableLastEditPage']) ? 1 : 0;
    }

    /**
     * readData event
     */
    protected function readData() {
        if ($this->eventObj instanceof PageEditForm && empty($_POST)) {
            $this->eventObj->additionalFields['enableLastEditPage'] = $this->eventObj->page->enableLastEditPage;
        }
    }

    /**
     * assignVariables event
     */
    protected function assignVariables() {
        $enableLastEditPage = true;

        if (isset($this->eventObj->additionalFields['enableLastEditPage']) && $this->eventObj->additionalFields['enableLastEditPage'] == 0) {
            $enableLastEditPage = false;
        }

        WCF::getTPL()->assign([
            'enableLastEditPage' => $enableLastEditPage
        ]);
    }
}